var mozless_focusMode = true;
var mozless_prefEmacsKeys;

function mozless_init(e) {
  mozless_prefEmacsKeys = mozlessReadPref('emacskeys');
}

window.addEventListener("load", mozless_init, true);

function mozless_focusTop() {
  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i].offsetTop >= w.pageYOffset
	&& links[i].offsetTop < w.pageYOffset + w.innerHeight) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusBottom()
{
  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i].offsetTop < w.pageYOffset + w.innerHeight
	&& links[i].offsetTop >= w.pageYOffset) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusPrev() {
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusBottom();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusBottom();
  }
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i] == focus) {
      if (i-1 >= 0) {
	links[i-1].focus();
	links[i-1].select();
      }
      return;
    }
  }
}

function mozless_focusNext() {
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusTop();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusTop();
  }
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i] == focus) {
      if (i+1 < links.length) {
	links[i+1].focus();
	links[i+1].select();
      }
      return;
    }
  }
}

//--------------------------------------------------------------------

function mozless_keyFocusMode()
{
  mozless_focusMode = !mozless_focusMode;
}

function mozless_keyPrev()
{
  if (mozless_focusMode) {
    mozless_focusPrev();
  } else {
    goDoCommand('cmd_scrollLineUp');
  }
}

function mozless_keyNext()
{
  if (mozless_focusMode) {
    mozless_focusNext();
  } else {
    goDoCommand('cmd_scrollLineDown');
  }
}

function mozless_keyBack()
{
  if (mozless_focusMode) {
    BrowserBack();
  } else {
    goDoCommand('cmd_scrollLeft');
  }
}

function mozless_followLink()
{
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) return;
  window._content.open(focus.href, "_self");
}

function mozless_keyForward()
{
  if (mozless_focusMode) {
    mozless_followLink();
  } else {
    goDoCommand('cmd_scrollRight');
  }
}

function mozless_keyPageUp()
{
  goDoCommand('cmd_scrollPageUp');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_keyPageDown()
{
  goDoCommand('cmd_scrollPageDown');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_keyHalfPageUp()
{
  window._content.scrollBy(0, -window._content.innerHeight/2);
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_keyHalfPageDown()
{
  window._content.scrollBy(0, window._content.innerHeight/2);
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_keyTop()
{
  goDoCommand('cmd_scrollTop');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_keyBottom()
{
  goDoCommand('cmd_scrollBottom');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_movePageUp()
{
  mozless_keyPageUp(); // XXX - Not a scrolling?
}

function mozless_movePageDown()
{
  mozless_keyPageDown(); // XXX - Not a scrolling?
}
