const DEBUG = false;

var packageName = "mozless";
var distributor = "mozdev";
var version = "0.1.2";
var jarName = packageName + ".jar";

var result;

result = initInstall(packageName, "/"+distributor+"/"+packageName, version);
if (DEBUG) logComment("initInstall: " + result);

var message =
"Select \"OK\" to install "+packageName+" to your user profile.\n"
+ "\n"
+ "Alternatively, select \"Cancel\" to install "+packageName+" to the application directory. In this case, system administering privileges may be required.\n"
;
var instToProfile = confirm(message);
var dir = instToProfile ? getFolder("Profile", "chrome") : getFolder("chrome");
result = addFile(packageName, jarName, dir, "");
if (DEBUG) logComment("addFile: " + result);

var location = instToProfile ? PROFILE_CHROME : DELAYED_CHROME;
var jar = getFolder(dir, jarName);
if (DEBUG) logComment("jar: " + jar);
result = registerChrome(CONTENT | location, jar, "content/");
if (DEBUG) logComment("registerChrome: " + result);

if (instToProfile) {
  var userPrefDir = getFolder("Profile");
  if (DEBUG) logComment("prefDir: " + userPrefDir);
  result = addFile(packageName, "user.js", userPrefDir, "");
  if (DEBUG) logComment("addFile[userPref]: " + result);
}

result = performInstall();
if (DEBUG) logComment("performInstall: " + result);
if (result == SUCCESS || result == REBOOT_NEEDED) {
  refreshPlugins();
  alert("Installation succeeded.\n"
	+ "Restart the application, and new keybindings will be enabled.");
} else {
  alert("Installation failed.\n" + "performInstall() have returned an error "+result+".");
  result = cancelInstall(result);
  if (DEBUG) logComment("cancelInstall: " + result);
}
